> For the complete documentation index, see [llms.txt](https://docs.wisej.com/ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.wisej.com/ai/components/api/smartadapter/wisej.ai.smartadapter.extendsattribute.md).

# SmartAdapter.ExtendsAttribute

Namespace: **Wisej.AI**

Assembly: **Wisej.AI** (3.5.0.0)

Represents an attribute that specifies the type a [SmartAdapter](/ai/components/api/smartadapter.md) extends, allowing for multiple extensions if specified.

{% tabs %}
{% tab title="C#" %}

```csharp
public class ExtendsAttribute : Attribute
```

{% endtab %}

{% tab title="VB.NET" %}

```visual-basic
Public Class ExtendsAttribute
    Inherits Attribute
```

{% endtab %}
{% endtabs %}

This attribute can be applied to [SmartAdapter](/ai/components/api/smartadapter.md) classes to indicate that they extend a particular type. It supports specifying the type either by a [Type](#type) object or by a type name string.

## Constructors

### ![](/files/ptrKjmmRoQB76pvrIqh0) ExtendsAttribute(type, allowMultiple)

Initializes a new instance of the [ExtendsAttribute](/ai/components/api/smartadapter/wisej.ai.smartadapter.extendsattribute.md) class with the specified type.

| Name              | Type                                                            | Description                                                            |
| ----------------- | --------------------------------------------------------------- | ---------------------------------------------------------------------- |
| **type**          | [Type](https://docs.microsoft.com/dotnet/api/system.type)       | The type that the class extends.                                       |
| **allowMultiple** | [Boolean](https://docs.microsoft.com/dotnet/api/system.boolean) | Indicates whether multiple extensions are allowed. Default is `false`. |

**Throws:**

* [ArgumentNullException](https://docs.microsoft.com/dotnet/api/system.argumentnullexception)\
  Thrown when the *type* is `null`.

### ![](/files/ptrKjmmRoQB76pvrIqh0) ExtendsAttribute(typeName, allowMultiple)

Initializes a new instance of the [ExtendsAttribute](/ai/components/api/smartadapter/wisej.ai.smartadapter.extendsattribute.md) class with the specified type name.

| Name              | Type                                                            | Description                                                            |
| ----------------- | --------------------------------------------------------------- | ---------------------------------------------------------------------- |
| **typeName**      | [String](https://docs.microsoft.com/dotnet/api/system.string)   | The name of the type that the class extends.                           |
| **allowMultiple** | [Boolean](https://docs.microsoft.com/dotnet/api/system.boolean) | Indicates whether multiple extensions are allowed. Default is `false`. |

**Throws:**

* [ArgumentNullException](https://docs.microsoft.com/dotnet/api/system.argumentnullexception)\
  Thrown when the *typeName* is `null`.

## Properties

### ![](/files/ptrKjmmRoQB76pvrIqh0) AllowMultiple

[Boolean](https://docs.microsoft.com/dotnet/api/system.boolean): Gets a value indicating whether the adapter can extend multiple controls.

### ![](/files/ptrKjmmRoQB76pvrIqh0) Type

[Type](https://docs.microsoft.com/dotnet/api/system.type): Gets the [Type](#type) object that the class extends.

If the type was specified by name, this property attempts to resolve it to a [Type](#type) object.

### ![](/files/ptrKjmmRoQB76pvrIqh0) TypeName

[String](https://docs.microsoft.com/dotnet/api/system.string): Gets the name of the type that the adapter can extend.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.wisej.com/ai/components/api/smartadapter/wisej.ai.smartadapter.extendsattribute.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
